SystemOrganization addCategory: #'Satellogic-Seaside2'!

WAComponent subclass: #ContentViewComponent
	instanceVariableNames: 'sateliteConsole show'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Satellogic-Seaside2'!

!ContentViewComponent class methodsFor: 'as yet unclassified' stamp: 'af 11/3/2013 22:52'!
createForSateliteConsole: aSateliteConsole 
^self new initializeForSateliteConsole: aSateliteConsole.! !

!ContentViewComponent methodsFor: 'as yet unclassified' stamp: 'af 11/4/2013 17:42'!
changeVisibility
show := show not.
! !

!ContentViewComponent methodsFor: 'as yet unclassified' stamp: 'af 11/3/2013 23:09'!
commandsLabelsOf: aSubSystemName 
| aNameCollection |
aNameCollection := OrderedCollection with: 'none'.
(sateliteConsole satellite subSystem:aSubSystemName commands) do: [ : aCommand| aNameCollection add: aCommand name  ] .
^ aNameCollection.
! !

!ContentViewComponent methodsFor: 'as yet unclassified' stamp: 'af 11/3/2013 23:03'!
commandsOf: aSubSystemName 
^sateliteConsole satellite subSystem:aSubSystemName commands.
! !

!ContentViewComponent methodsFor: 'as yet unclassified' stamp: 'af 11/3/2013 22:52'!
initializeForSateliteConsole: aSateliteConsole
super initialize.
sateliteConsole := aSateliteConsole.! !

!ContentViewComponent methodsFor: 'as yet unclassified' stamp: 'af 11/6/2013 10:53'!
isVisible
^show! !

!ContentViewComponent methodsFor: 'as yet unclassified' stamp: 'af 11/6/2013 10:54'!
satelliteConsole
^sateliteConsole! !

!ContentViewComponent methodsFor: 'as yet unclassified' stamp: 'af 11/3/2013 22:59'!
systemLabels
| systemNameCollection |
systemNameCollection := OrderedCollection  with:'none'.
sateliteConsole satellite systems do:[:aSubSystem| systemNameCollection add: aSubSystem name].
^systemNameCollection.! !

!ContentViewComponent methodsFor: 'as yet unclassified' stamp: 'af 11/3/2013 23:00'!
systems
^ sateliteConsole satellite systems ! !

ContentViewComponent subclass: #Filter
	instanceVariableNames: 'selectedSystem selectedCommand sateliteConsole show showSignals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Satellogic-Seaside2'!

!Filter class methodsFor: 'as yet unclassified' stamp: 'af 11/3/2013 23:14'!
createWithSateliteConsole: aSateliteConsole 
| newFilter |
newFilter := self createForSateliteConsole: aSateliteConsole. 
newFilter setDefaults.! !

!Filter methodsFor: 'private' stamp: 'a 11/8/2013 00:24'!
add:anElement toCollection: aCollection whenTrue: aBoolean 
aBoolean ifTrue:[^ aCollection add: anElement  ].
^aCollection.! !

!Filter methodsFor: 'command call filtering' stamp: 'a 11/8/2013 00:10'!
decideCommandCall: aCommandCall
^( selectedSystem = 'none' or:( aCommandCall subSystem name  includesSubstring: selectedSystem)  ) and: (selectedCommand = 'none' or:( aCommandCall command identifier name  includesSubstring: selectedCommand) )! !

!Filter methodsFor: 'record filtering' stamp: 'a 11/8/2013 00:12'!
decideFor: aRecord 
(aRecord isKindOf: #SignalRecord) ifTrue:[
	^self decideForSignal: aRecord.	
	] .
^self decideForCommandAwnserRecord: aRecord.
! !

!Filter methodsFor: 'record filtering' stamp: 'a 11/8/2013 00:56'!
decideForCommandAwnserRecord: aRecord
| condition filteredCommandCalls |
"creates (if posible) a new commandAwnserRecord wich contains only filtered command calls "

filteredCommandCalls := self filterCommandCall: aRecord commandCall.
condition :=  (filteredCommandCalls) isEmpty not.

^self add: ( 
	CommandAnswerRecord of: (aRecord parsedAnswer) 
							fromSatelliteAnswer: (aRecord satelliteAnswer) 
							withCommandCall: filteredCommandCalls) 
	toCollection: (OrderedCollection new) 
	whenTrue:  condition.! !

!Filter methodsFor: 'signal filtering' stamp: 'a 11/8/2013 00:29'!
decideForSignal: aRecord
^self add: aRecord toCollection: (OrderedCollection new)  whenTrue: showSignals
	
! !

!Filter methodsFor: 'command call filtering' stamp: 'a 11/8/2013 00:57'!
filterCommandCall: aCommandCall
( aCommandCall isKindOf: #SimpleCommandCall) ifTrue:[ 
	^ self filterSimpleCommandCall: aCommandCall].

	^ self filterCompoundCommandCall: aCommandCall.! !

!Filter methodsFor: 'command call filtering' stamp: 'a 11/8/2013 00:17'!
filterCompoundCommandCall: aCommandCall
^ aCommandCall commands select:[ :each | self decideCommandCall:  each  ].
! !

!Filter methodsFor: 'command call filtering' stamp: 'a 11/8/2013 00:26'!
filterSimpleCommandCall: aCommandCall
^self add: aCommandCall toCollection: (OrderedCollection new) whenTrue: (self decideCommandCall: aCommandCall) ! !

!Filter methodsFor: 'rendering' stamp: 'a 11/7/2013 23:24'!
renderContentOn: aCanvas

	
	aCanvas form:[
		
		aCanvas break.
		show ifTrue:[
		aCanvas checkbox 
                        value: showSignals ;	
                        callback: [:value | showSignals := value];
				value:' filter beacons and telemetries' .
		aCanvas break.
		aCanvas  select 
          	  list: ( self systemsLabels);
			selected: selectedSystem;
			callback: [ :value |selectedSystem := value ]. 
		
			aCanvas submitButton
            	callback: [  ];
            	value: 'find commands'.
		
		aCanvas  select 
        	    list: (self commandsLabelsOf:( selectedSystem ));
			selected: selectedCommand;
			callback: [ :value |selectedCommand := value ]. 
		
		aCanvas submitButton
            	callback: [ ];
            	value: 'filter'.

		].


	aCanvas break.
	
	aCanvas button
            callback: [self changeVisibility ];
            value: 'View Filter  '. 
	].! !

!Filter methodsFor: 'rendering' stamp: 'af 11/7/2013 19:23'!
renderHeaderOn:aCanvas
	aCanvas text:' |FILTER | System to Filter:  ',selectedSystem , ' Command to Filter:  ',selectedCommand .! !

ContentViewComponent subclass: #InstructionAdder
	instanceVariableNames: 'selectedSystem selectedCommand inputList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Satellogic-Seaside2'!

!InstructionAdder methodsFor: 'sending' stamp: 'af 11/6/2013 10:56'!
makeCommandCall
| sateliteDefinition selectedSystemDefinition selectedCommandDefinition |
sateliteDefinition := self satelliteConsole satellite.
selectedSystemDefinition := sateliteDefinition subSystem: selectedSystem .
selectedCommandDefinition := selectedSystemDefinition command: selectedCommand.
^CommandCall for: selectedCommandDefinition from: selectedSystemDefinition in: sateliteDefinition withInputParameters:  inputList.! !

!InstructionAdder methodsFor: 'rendering' stamp: 'af 11/6/2013 11:03'!
renderContentOn: aCanvas

	| parameter |
	aCanvas form:[
		
		aCanvas button
            callback: [self changeVisibility ];
            value: 'Add Instruction  '. 
		aCanvas break.
		
		self isVisible ifTrue:[
			
			aCanvas  select 
          		  list: (self systemsLabels);
			  selected: selectedSystem ;
			 callback: [ :value |selectedSystem := value ]. 
			aCanvas submitButton
           		 callback: [];
          		  value: 'find commands '.	
		     aCanvas  select 
           		 list: (self commandsLabelsOf:( selectedSystem ));
			selected: selectedCommand;
			callback: [ :value |selectedCommand := value ]. 
			aCanvas submitButton
           		 callback: [];
          		  value: 'select command '.
			aCanvas break.	
			aCanvas break.	
				aCanvas text:' enter parameters '.		
			aCanvas textInput
						value: parameter;
						callback: [ :value | 							
							inputList add: value ].
			aCanvas break.
			aCanvas submitButton
           		 callback: [];
          		  value: 'ADD'.
			aCanvas break.
			aCanvas unorderedList with: inputList.
			aCanvas break.
			aCanvas submitButton
           			 callback: [inputList := OrderedCollection new ];
          			  value: 'CLEAR PARAMETERS'.
			aCanvas break.
			aCanvas break.
			aCanvas submitButton
           			 callback: self send. ];
          			  value: 'SEND'.
		]	
		
	! !

!InstructionAdder methodsFor: 'sending' stamp: 'af 11/6/2013 10:57'!
send
self satelliteConsole send: (self makeCommandCall).! !
